/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.mapping;

/** Object that provide the value to store in a column
 *
 */
public interface Generator
{
    /** This method is called by the custom XMLCollection storage algorithm when a
     * user-generated column of a relational table is filled. The Object type returned
     * must be consistent with column target SQL type.
     * @param context Passed by the mapping algorithm to provide an access
     * to storage system variables.
     * @return An Object, that must be, from a JDBC 2.0 point of view,
     * consistent with column target SQL type.
     */
    Object getValue(StorageContext context);
}
